import{S as ar,i as lr,s as rr,e as r,k as p,w as g,t as a,M as ir,c as i,d as s,m as f,a as n,x as _,h as l,b as c,T as sr,G as t,g as h,y as b,q as v,o as y,B as w,v as or}from"../chunks/vendor-hf-doc-builder.js";import{T as nr}from"../chunks/Tip-hf-doc-builder.js";import{I as ms}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as q}from"../chunks/CodeBlock-hf-doc-builder.js";function hr($t){let u,J,d,k,C,$,se,N;return{c(){u=r("p"),J=a("Before continuing, please we aware that "),d=r("a"),k=a("ModelSearchArguments"),C=a(" and "),$=r("a"),se=a("DatasetSearchArguments"),N=a(`
are legacy helpers meant for exploratory purposes only. Their initialization require listing
all models and datasets on the Hub which makes them increasingly slower as the number of repos
on the Hub increases. For some production-ready code, consider passing raw strings when making
a filtered search on the Hub.`),this.h()},l(O){u=i(O,"P",{});var j=n(u);J=l(j,"Before continuing, please we aware that "),d=i(j,"A",{href:!0});var F=n(d);k=l(F,"ModelSearchArguments"),F.forEach(s),C=l(j," and "),$=i(j,"A",{href:!0});var ve=n($);se=l(ve,"DatasetSearchArguments"),ve.forEach(s),N=l(j,`
are legacy helpers meant for exploratory purposes only. Their initialization require listing
all models and datasets on the Hub which makes them increasingly slower as the number of repos
on the Hub increases. For some production-ready code, consider passing raw strings when making
a filtered search on the Hub.`),j.forEach(s),this.h()},h(){c(d,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelSearchArguments"),c($,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.DatasetSearchArguments")},m(O,j){h(O,u,j),t(u,J),t(u,d),t(d,k),t(u,C),t(u,$),t($,se),t(u,N)},d(O){O&&s(u)}}}function pr($t){let u,J,d,k,C,$,se,N,O,j,F,ve,Ge,ds,gs,xt,I,G,Ke,ae,_s,Ue,bs,jt,L,We,vs,ys,ye,ws,$s,Et,le,kt,K,xs,we,js,Es,At,M,ks,$e,As,Ts,xe,Fs,Ms,Tt,z,U,Ye,re,Hs,Xe,Ps,Ft,je,Ss,Mt,A,Ze,Qe,Ds,qs,Ve,et,Cs,Ns,tt,st,Os,Is,at,Ls,Ht,m,zs,lt,Bs,Rs,rt,Js,Gs,it,Ks,Us,ot,Ws,Ys,Ee,Xs,Zs,ke,Qs,Vs,Pt,W,ea,Ae,ta,sa,St,ie,Dt,Te,aa,qt,oe,Ct,B,Y,nt,ne,la,ht,ra,Nt,Fe,ia,Ot,E,Me,oa,na,He,ha,pa,pt,fa,ca,ft,ua,ma,It,he,Lt,X,zt,Z,da,ct,ga,_a,Bt,pe,Rt,H,ba,ut,va,ya,mt,wa,$a,Jt,Q,xa,dt,ja,Ea,Gt,fe,Kt,P,ka,gt,Aa,Ta,_t,Fa,Ma,Ut,ce,Wt,S,Ha,bt,Pa,Sa,vt,Da,qa,Yt,Pe,Se,Qa,Xt,De,qe,Va,Zt,D,Ca,Ce,Na,Oa,Ne,Ia,La,Qt,ue,Vt,V,za,yt,Ba,Ra,es,me,ts,Oe,Ja,ss,de,as,T,Ga,Ie,Ka,Ua,ge,Wa,Ya,_e,Xa,Za,ls;return $=new ms({}),ae=new ms({}),le=new q({props:{code:`from huggingface_hub import HfApi
api = HfApi()
models = api.list_models()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> HfApi
<span class="hljs-meta">&gt;&gt;&gt; </span>api = HfApi()
<span class="hljs-meta">&gt;&gt;&gt; </span>models = api.list_models()`}}),re=new ms({}),ie=new q({props:{code:`models = hf_api.list_models(
    filter=ModelFilter(
		task="image-classification",
		library="pytorch",
		trained_dataset="imagenet"
	)
)`,highlighted:`models = hf_api.list_models(
    <span class="hljs-built_in">filter</span>=ModelFilter(
		task=<span class="hljs-string">&quot;image-classification&quot;</span>,
		library=<span class="hljs-string">&quot;pytorch&quot;</span>,
		trained_dataset=<span class="hljs-string">&quot;imagenet&quot;</span>
	)
)`}}),oe=new q({props:{code:'list_datasets(sort="downloads", direction=-1, limit=5)',highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>list_datasets(sort=<span class="hljs-string">&quot;downloads&quot;</span>, direction=-<span class="hljs-number">1</span>, limit=<span class="hljs-number">5</span>)
[DatasetInfo: {
        <span class="hljs-built_in">id</span>: glue
		downloads: <span class="hljs-number">897789</span>
		(...)`}}),ne=new ms({}),he=new q({props:{code:`from huggingface_hub import ModelSearchArguments, DatasetSearchArguments

model_args = ModelSearchArguments()
dataset_args = DatasetSearchArguments()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> ModelSearchArguments, DatasetSearchArguments

<span class="hljs-meta">&gt;&gt;&gt; </span>model_args = ModelSearchArguments()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset_args = DatasetSearchArguments()`}}),X=new nr({props:{warning:!0,$$slots:{default:[hr]},$$scope:{ctx:$t}}}),pe=new q({props:{code:"model_args",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>model_args
Available Attributes <span class="hljs-keyword">or</span> Keys:
 * author
 * dataset
 * language
 * library
 * license
 * model_name
 * pipeline_tag`}}),fe=new q({props:{code:"model_args.library",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>model_args.library
Available Attributes <span class="hljs-keyword">or</span> Keys:
 * AdapterTransformers
 * Asteroid
 * ESPnet
 * Fairseq
 * Flair
 * JAX
 * Joblib
 * Keras
 * ONNX
 * PyTorch
 * Rust
 * Scikit_learn
 * SentenceTransformers
 * Stable_Baselines3 (Key only)
 * Stanza
 * TFLite
 * TensorBoard
 * TensorFlow
 * TensorFlowTTS
 * Timm
 * Transformers
 * allenNLP
 * fastText
 * fastai
 * pyannote_audio
 * spaCy
 * speechbrain`}}),ce=new q({props:{code:"model_args.library.PyTorch",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>model_args.library.PyTorch
<span class="hljs-string">&#x27;pytorch&#x27;</span>`}}),ue=new q({props:{code:`from huggingface_hub import ModelFilter, DatasetFilter

filt = ModelFilter(
    task=model_args.pipeline_tag.TextClassification, 
    trained_dataset=dataset_args.dataset_name.glue, 
    library=model_args.library.PyTorch
)
api.list_models(filter=filt)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> ModelFilter, DatasetFilter

<span class="hljs-meta">&gt;&gt;&gt; </span>filt = ModelFilter(
<span class="hljs-meta">... </span>    task=model_args.pipeline_tag.TextClassification, 
<span class="hljs-meta">... </span>    trained_dataset=dataset_args.dataset_name.glue, 
<span class="hljs-meta">... </span>    library=model_args.library.PyTorch
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>api.list_models(<span class="hljs-built_in">filter</span>=filt)[<span class="hljs-number">0</span>]
ModelInfo: {
	modelId: Jiva/xlm-roberta-large-it-mnli
	sha: c6e64469ec4aa17fedbd1b2522256f90a90b5b86
	lastModified: <span class="hljs-number">2021</span>-<span class="hljs-number">12</span>-10T14:<span class="hljs-number">56</span>:<span class="hljs-number">38.000</span>Z
	tags: [<span class="hljs-string">&#x27;pytorch&#x27;</span>, <span class="hljs-string">&#x27;xlm-roberta&#x27;</span>, <span class="hljs-string">&#x27;text-classification&#x27;</span>, <span class="hljs-string">&#x27;it&#x27;</span>, <span class="hljs-string">&#x27;dataset:multi_nli&#x27;</span>, <span class="hljs-string">&#x27;dataset:glue&#x27;</span>, <span class="hljs-string">&#x27;arxiv:1911.02116&#x27;</span>, <span class="hljs-string">&#x27;transformers&#x27;</span>, <span class="hljs-string">&#x27;tensorflow&#x27;</span>, <span class="hljs-string">&#x27;license:mit&#x27;</span>, <span class="hljs-string">&#x27;zero-shot-classification&#x27;</span>]
	pipeline_tag: zero-shot-classification
	siblings: [ModelFile(rfilename=<span class="hljs-string">&#x27;.gitattributes&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;README.md&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;config.json&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;pytorch_model.bin&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;sentencepiece.bpe.model&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;special_tokens_map.json&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;tokenizer.json&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;tokenizer_config.json&#x27;</span>)]
	config: <span class="hljs-literal">None</span>
	<span class="hljs-built_in">id</span>: Jiva/xlm-roberta-large-it-mnli
	private: <span class="hljs-literal">False</span>
	downloads: <span class="hljs-number">11061</span>
	library_name: transformers
	likes: <span class="hljs-number">1</span>
}`}}),me=new q({props:{code:`filt = ModelFilter(
    task=model_args.pipeline_tag.TextClassification, 
    library=[model_args.library.PyTorch, model_args.library.TensorFlow]
)
api.list_models(filter=filt)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>filt = ModelFilter(
<span class="hljs-meta">... </span>    task=model_args.pipeline_tag.TextClassification, 
<span class="hljs-meta">... </span>    library=[model_args.library.PyTorch, model_args.library.TensorFlow]
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>api.list_models(<span class="hljs-built_in">filter</span>=filt)[<span class="hljs-number">0</span>]
ModelInfo: {
	modelId: distilbert-base-uncased-finetuned-sst-<span class="hljs-number">2</span>-english
	sha: ada5cc01a40ea664f0a490d0b5f88c97ab460470
	lastModified: <span class="hljs-number">2022</span>-03-22T19:<span class="hljs-number">47</span>:<span class="hljs-number">08.000</span>Z
	tags: [<span class="hljs-string">&#x27;pytorch&#x27;</span>, <span class="hljs-string">&#x27;tf&#x27;</span>, <span class="hljs-string">&#x27;rust&#x27;</span>, <span class="hljs-string">&#x27;distilbert&#x27;</span>, <span class="hljs-string">&#x27;text-classification&#x27;</span>, <span class="hljs-string">&#x27;en&#x27;</span>, <span class="hljs-string">&#x27;dataset:sst-2&#x27;</span>, <span class="hljs-string">&#x27;transformers&#x27;</span>, <span class="hljs-string">&#x27;license:apache-2.0&#x27;</span>, <span class="hljs-string">&#x27;infinity_compatible&#x27;</span>]
	pipeline_tag: text-classification
	siblings: [ModelFile(rfilename=<span class="hljs-string">&#x27;.gitattributes&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;README.md&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;config.json&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;map.jpeg&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;pytorch_model.bin&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;rust_model.ot&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;tf_model.h5&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;tokenizer_config.json&#x27;</span>), ModelFile(rfilename=<span class="hljs-string">&#x27;vocab.txt&#x27;</span>)]
	config: <span class="hljs-literal">None</span>
	<span class="hljs-built_in">id</span>: distilbert-base-uncased-finetuned-sst-<span class="hljs-number">2</span>-english
	private: <span class="hljs-literal">False</span>
	downloads: <span class="hljs-number">3917525</span>
	library_name: transformers
	likes: <span class="hljs-number">49</span>
}`}}),de=new q({props:{code:`filt = ModelFilter(
    task="text-classification", 
    library=["pytorch", "tensorflow"],
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>filt = ModelFilter(
<span class="hljs-meta">... </span>    task=<span class="hljs-string">&quot;text-classification&quot;</span>, 
<span class="hljs-meta">... </span>    library=[<span class="hljs-string">&quot;pytorch&quot;</span>, <span class="hljs-string">&quot;tensorflow&quot;</span>],
<span class="hljs-meta">... </span>)`}}),{c(){u=r("meta"),J=p(),d=r("h1"),k=r("a"),C=r("span"),g($.$$.fragment),se=p(),N=r("span"),O=a("Searching the Hub"),j=p(),F=r("p"),ve=a("In this tutorial, you will learn how to search models, datasets and spaces on the Hub using "),Ge=r("code"),ds=a("huggingface_hub"),gs=a("."),xt=p(),I=r("h2"),G=r("a"),Ke=r("span"),g(ae.$$.fragment),_s=p(),Ue=r("span"),bs=a("How to list repositories ?"),jt=p(),L=r("p"),We=r("code"),vs=a("huggingface_hub"),ys=a(" library includes an HTTP client "),ye=r("a"),ws=a("HfApi"),$s=a(` to interact with the Hub.
Among other things, it can list models, datasets and spaces stored on the Hub:`),Et=p(),g(le.$$.fragment),kt=p(),K=r("p"),xs=a("The output of "),we=r("a"),js=a("list_models()"),Es=a(" is an iterator over the models stored on the Hub."),At=p(),M=r("p"),ks=a("Similarly, you can use "),$e=r("a"),As=a("list_datasets()"),Ts=a(" to list datasets and "),xe=r("a"),Fs=a("list_spaces()"),Ms=a(" to list Spaces."),Tt=p(),z=r("h2"),U=r("a"),Ye=r("span"),g(re.$$.fragment),Hs=p(),Xe=r("span"),Ps=a("How to filter repositories ?"),Ft=p(),je=r("p"),Ss=a(`Listing repositories is great but now you might want to filter your search.
The list helpers have several attributes like:`),Mt=p(),A=r("ul"),Ze=r("li"),Qe=r("code"),Ds=a("filter"),qs=p(),Ve=r("li"),et=r("code"),Cs=a("author"),Ns=p(),tt=r("li"),st=r("code"),Os=a("search"),Is=p(),at=r("li"),Ls=a("\u2026"),Ht=p(),m=r("p"),zs=a("Two of these parameters are intuitive ("),lt=r("code"),Bs=a("author"),Rs=a(" and "),rt=r("code"),Js=a("search"),Gs=a("), but what about that "),it=r("code"),Ks=a("filter"),Us=a(`?
`),ot=r("code"),Ws=a("filter"),Ys=a(" takes as input a "),Ee=r("a"),Xs=a("ModelFilter"),Zs=a(" object (or "),ke=r("a"),Qs=a("DatasetFilter"),Vs=a(`). You can instantiate
it by specifying which models you want to filter.`),Pt=p(),W=r("p"),ea=a(`Let\u2019s see an example to get all models on the Hub that does image classification, have been
trained on the imagenet dataset and that runs with PyTorch. That can be done with a single
`),Ae=r("a"),ta=a("ModelFilter"),sa=a(". Attributes are combined as \u201Clogical AND\u201D."),St=p(),g(ie.$$.fragment),Dt=p(),Te=r("p"),aa=a(`While filtering, you can also sort the models and take only the top results. For example,
the following example fetches the top 5 most downloaded datasets on the Hub:`),qt=p(),g(oe.$$.fragment),Ct=p(),B=r("h2"),Y=r("a"),nt=r("span"),g(ne.$$.fragment),la=p(),ht=r("span"),ra=a("How to explore filter options ?"),Nt=p(),Fe=r("p"),ia=a(`Now you know how to filter your list of models/datasets/spaces. The problem you might
have is that you don\u2019t know exactly what you are looking for. No worries! We also provide
some helpers that allows you to discover what arguments can be passed in your query.`),Ot=p(),E=r("p"),Me=r("a"),oa=a("ModelSearchArguments"),na=a(" and "),He=r("a"),ha=a("DatasetSearchArguments"),pa=a(` are nested namespace objects that
have `),pt=r("strong"),fa=a("every single option"),ca=a(` available on the Hub and that will return what should be passed
to `),ft=r("code"),ua=a("filter"),ma=a(". The best of all is: it has tab completion \u{1F38A} ."),It=p(),g(he.$$.fragment),Lt=p(),g(X.$$.fragment),zt=p(),Z=r("p"),da=a("Now, let\u2019s check what is available in "),ct=r("code"),ga=a("model_args"),_a=a(" by checking it\u2019s output, you will find:"),Bt=p(),g(pe.$$.fragment),Rt=p(),H=r("p"),ba=a(`It has a variety of attributes or keys available to you. This is because it is both an object
and a dictionary, so you can either do `),ut=r("code"),va=a('model_args["author"]'),ya=a(" or "),mt=r("code"),wa=a("model_args.author"),$a=a("."),Jt=p(),Q=r("p"),xa=a("The first criteria is getting all PyTorch models. This would be found under the "),dt=r("code"),ja=a("library"),Ea=a(" attribute, so let\u2019s see if it is there:"),Gt=p(),g(fe.$$.fragment),Kt=p(),P=r("p"),ka=a("It is! The "),gt=r("code"),Aa=a("PyTorch"),Ta=a(" name is there, so you\u2019ll need to use "),_t=r("code"),Fa=a("model_args.library.PyTorch"),Ma=a(":"),Ut=p(),g(ce.$$.fragment),Wt=p(),S=r("p"),Ha=a("Below is an animation repeating the process for finding both the "),bt=r("code"),Pa=a("Text Classification"),Sa=a(" and "),vt=r("code"),Da=a("glue"),qa=a(" requirements:"),Yt=p(),Pe=r("p"),Se=r("img"),Xt=p(),De=r("p"),qe=r("img"),Zt=p(),D=r("p"),Ca=a(`Now that all the pieces are there, the last step is to combine them all for something the
API can use through the `),Ce=r("a"),Na=a("ModelFilter"),Oa=a(" and "),Ne=r("a"),Ia=a("DatasetFilter"),La=a(" classes (i.e. strings)."),Qt=p(),g(ue.$$.fragment),Vt=p(),V=r("p"),za=a(`As you can see, it found the models that fit all the criteria. You can even take it further
by passing in an array for each of the parameters from before. For example, let\u2019s take a look
for the same configuration, but also include `),yt=r("code"),Ba=a("TensorFlow"),Ra=a(" in the filter:"),es=p(),g(me.$$.fragment),ts=p(),Oe=r("p"),Ja=a("This query is strictly equivalent to:"),ss=p(),g(de.$$.fragment),as=p(),T=r("p"),Ga=a("Here, the "),Ie=r("a"),Ka=a("ModelSearchArguments"),Ua=a(` has been a helper to explore the options available on the Hub.
However, it is not a requirement to make a search. Another way to do that is to visit the
`),ge=r("a"),Wa=a("models"),Ya=a(" and "),_e=r("a"),Xa=a("datasets"),Za=a(` pages
in your browser, search for some parameters and look at the values in the URL.`),this.h()},l(e){const o=ir('[data-svelte="svelte-1phssyn"]',document.head);u=i(o,"META",{name:!0,content:!0}),o.forEach(s),J=f(e),d=i(e,"H1",{class:!0});var be=n(d);k=i(be,"A",{id:!0,class:!0,href:!0});var el=n(k);C=i(el,"SPAN",{});var tl=n(C);_($.$$.fragment,tl),tl.forEach(s),el.forEach(s),se=f(be),N=i(be,"SPAN",{});var sl=n(N);O=l(sl,"Searching the Hub"),sl.forEach(s),be.forEach(s),j=f(e),F=i(e,"P",{});var rs=n(F);ve=l(rs,"In this tutorial, you will learn how to search models, datasets and spaces on the Hub using "),Ge=i(rs,"CODE",{});var al=n(Ge);ds=l(al,"huggingface_hub"),al.forEach(s),gs=l(rs,"."),rs.forEach(s),xt=f(e),I=i(e,"H2",{class:!0});var is=n(I);G=i(is,"A",{id:!0,class:!0,href:!0});var ll=n(G);Ke=i(ll,"SPAN",{});var rl=n(Ke);_(ae.$$.fragment,rl),rl.forEach(s),ll.forEach(s),_s=f(is),Ue=i(is,"SPAN",{});var il=n(Ue);bs=l(il,"How to list repositories ?"),il.forEach(s),is.forEach(s),jt=f(e),L=i(e,"P",{});var wt=n(L);We=i(wt,"CODE",{});var ol=n(We);vs=l(ol,"huggingface_hub"),ol.forEach(s),ys=l(wt," library includes an HTTP client "),ye=i(wt,"A",{href:!0});var nl=n(ye);ws=l(nl,"HfApi"),nl.forEach(s),$s=l(wt,` to interact with the Hub.
Among other things, it can list models, datasets and spaces stored on the Hub:`),wt.forEach(s),Et=f(e),_(le.$$.fragment,e),kt=f(e),K=i(e,"P",{});var os=n(K);xs=l(os,"The output of "),we=i(os,"A",{href:!0});var hl=n(we);js=l(hl,"list_models()"),hl.forEach(s),Es=l(os," is an iterator over the models stored on the Hub."),os.forEach(s),At=f(e),M=i(e,"P",{});var Le=n(M);ks=l(Le,"Similarly, you can use "),$e=i(Le,"A",{href:!0});var pl=n($e);As=l(pl,"list_datasets()"),pl.forEach(s),Ts=l(Le," to list datasets and "),xe=i(Le,"A",{href:!0});var fl=n(xe);Fs=l(fl,"list_spaces()"),fl.forEach(s),Ms=l(Le," to list Spaces."),Le.forEach(s),Tt=f(e),z=i(e,"H2",{class:!0});var ns=n(z);U=i(ns,"A",{id:!0,class:!0,href:!0});var cl=n(U);Ye=i(cl,"SPAN",{});var ul=n(Ye);_(re.$$.fragment,ul),ul.forEach(s),cl.forEach(s),Hs=f(ns),Xe=i(ns,"SPAN",{});var ml=n(Xe);Ps=l(ml,"How to filter repositories ?"),ml.forEach(s),ns.forEach(s),Ft=f(e),je=i(e,"P",{});var dl=n(je);Ss=l(dl,`Listing repositories is great but now you might want to filter your search.
The list helpers have several attributes like:`),dl.forEach(s),Mt=f(e),A=i(e,"UL",{});var ee=n(A);Ze=i(ee,"LI",{});var gl=n(Ze);Qe=i(gl,"CODE",{});var _l=n(Qe);Ds=l(_l,"filter"),_l.forEach(s),gl.forEach(s),qs=f(ee),Ve=i(ee,"LI",{});var bl=n(Ve);et=i(bl,"CODE",{});var vl=n(et);Cs=l(vl,"author"),vl.forEach(s),bl.forEach(s),Ns=f(ee),tt=i(ee,"LI",{});var yl=n(tt);st=i(yl,"CODE",{});var wl=n(st);Os=l(wl,"search"),wl.forEach(s),yl.forEach(s),Is=f(ee),at=i(ee,"LI",{});var $l=n(at);Ls=l($l,"\u2026"),$l.forEach(s),ee.forEach(s),Ht=f(e),m=i(e,"P",{});var x=n(m);zs=l(x,"Two of these parameters are intuitive ("),lt=i(x,"CODE",{});var xl=n(lt);Bs=l(xl,"author"),xl.forEach(s),Rs=l(x," and "),rt=i(x,"CODE",{});var jl=n(rt);Js=l(jl,"search"),jl.forEach(s),Gs=l(x,"), but what about that "),it=i(x,"CODE",{});var El=n(it);Ks=l(El,"filter"),El.forEach(s),Us=l(x,`?
`),ot=i(x,"CODE",{});var kl=n(ot);Ws=l(kl,"filter"),kl.forEach(s),Ys=l(x," takes as input a "),Ee=i(x,"A",{href:!0});var Al=n(Ee);Xs=l(Al,"ModelFilter"),Al.forEach(s),Zs=l(x," object (or "),ke=i(x,"A",{href:!0});var Tl=n(ke);Qs=l(Tl,"DatasetFilter"),Tl.forEach(s),Vs=l(x,`). You can instantiate
it by specifying which models you want to filter.`),x.forEach(s),Pt=f(e),W=i(e,"P",{});var hs=n(W);ea=l(hs,`Let\u2019s see an example to get all models on the Hub that does image classification, have been
trained on the imagenet dataset and that runs with PyTorch. That can be done with a single
`),Ae=i(hs,"A",{href:!0});var Fl=n(Ae);ta=l(Fl,"ModelFilter"),Fl.forEach(s),sa=l(hs,". Attributes are combined as \u201Clogical AND\u201D."),hs.forEach(s),St=f(e),_(ie.$$.fragment,e),Dt=f(e),Te=i(e,"P",{});var Ml=n(Te);aa=l(Ml,`While filtering, you can also sort the models and take only the top results. For example,
the following example fetches the top 5 most downloaded datasets on the Hub:`),Ml.forEach(s),qt=f(e),_(oe.$$.fragment,e),Ct=f(e),B=i(e,"H2",{class:!0});var ps=n(B);Y=i(ps,"A",{id:!0,class:!0,href:!0});var Hl=n(Y);nt=i(Hl,"SPAN",{});var Pl=n(nt);_(ne.$$.fragment,Pl),Pl.forEach(s),Hl.forEach(s),la=f(ps),ht=i(ps,"SPAN",{});var Sl=n(ht);ra=l(Sl,"How to explore filter options ?"),Sl.forEach(s),ps.forEach(s),Nt=f(e),Fe=i(e,"P",{});var Dl=n(Fe);ia=l(Dl,`Now you know how to filter your list of models/datasets/spaces. The problem you might
have is that you don\u2019t know exactly what you are looking for. No worries! We also provide
some helpers that allows you to discover what arguments can be passed in your query.`),Dl.forEach(s),Ot=f(e),E=i(e,"P",{});var R=n(E);Me=i(R,"A",{href:!0});var ql=n(Me);oa=l(ql,"ModelSearchArguments"),ql.forEach(s),na=l(R," and "),He=i(R,"A",{href:!0});var Cl=n(He);ha=l(Cl,"DatasetSearchArguments"),Cl.forEach(s),pa=l(R,` are nested namespace objects that
have `),pt=i(R,"STRONG",{});var Nl=n(pt);fa=l(Nl,"every single option"),Nl.forEach(s),ca=l(R,` available on the Hub and that will return what should be passed
to `),ft=i(R,"CODE",{});var Ol=n(ft);ua=l(Ol,"filter"),Ol.forEach(s),ma=l(R,". The best of all is: it has tab completion \u{1F38A} ."),R.forEach(s),It=f(e),_(he.$$.fragment,e),Lt=f(e),_(X.$$.fragment,e),zt=f(e),Z=i(e,"P",{});var fs=n(Z);da=l(fs,"Now, let\u2019s check what is available in "),ct=i(fs,"CODE",{});var Il=n(ct);ga=l(Il,"model_args"),Il.forEach(s),_a=l(fs," by checking it\u2019s output, you will find:"),fs.forEach(s),Bt=f(e),_(pe.$$.fragment,e),Rt=f(e),H=i(e,"P",{});var ze=n(H);ba=l(ze,`It has a variety of attributes or keys available to you. This is because it is both an object
and a dictionary, so you can either do `),ut=i(ze,"CODE",{});var Ll=n(ut);va=l(Ll,'model_args["author"]'),Ll.forEach(s),ya=l(ze," or "),mt=i(ze,"CODE",{});var zl=n(mt);wa=l(zl,"model_args.author"),zl.forEach(s),$a=l(ze,"."),ze.forEach(s),Jt=f(e),Q=i(e,"P",{});var cs=n(Q);xa=l(cs,"The first criteria is getting all PyTorch models. This would be found under the "),dt=i(cs,"CODE",{});var Bl=n(dt);ja=l(Bl,"library"),Bl.forEach(s),Ea=l(cs," attribute, so let\u2019s see if it is there:"),cs.forEach(s),Gt=f(e),_(fe.$$.fragment,e),Kt=f(e),P=i(e,"P",{});var Be=n(P);ka=l(Be,"It is! The "),gt=i(Be,"CODE",{});var Rl=n(gt);Aa=l(Rl,"PyTorch"),Rl.forEach(s),Ta=l(Be," name is there, so you\u2019ll need to use "),_t=i(Be,"CODE",{});var Jl=n(_t);Fa=l(Jl,"model_args.library.PyTorch"),Jl.forEach(s),Ma=l(Be,":"),Be.forEach(s),Ut=f(e),_(ce.$$.fragment,e),Wt=f(e),S=i(e,"P",{});var Re=n(S);Ha=l(Re,"Below is an animation repeating the process for finding both the "),bt=i(Re,"CODE",{});var Gl=n(bt);Pa=l(Gl,"Text Classification"),Gl.forEach(s),Sa=l(Re," and "),vt=i(Re,"CODE",{});var Kl=n(vt);Da=l(Kl,"glue"),Kl.forEach(s),qa=l(Re," requirements:"),Re.forEach(s),Yt=f(e),Pe=i(e,"P",{});var Ul=n(Pe);Se=i(Ul,"IMG",{src:!0,alt:!0}),Ul.forEach(s),Xt=f(e),De=i(e,"P",{});var Wl=n(De);qe=i(Wl,"IMG",{src:!0,alt:!0}),Wl.forEach(s),Zt=f(e),D=i(e,"P",{});var Je=n(D);Ca=l(Je,`Now that all the pieces are there, the last step is to combine them all for something the
API can use through the `),Ce=i(Je,"A",{href:!0});var Yl=n(Ce);Na=l(Yl,"ModelFilter"),Yl.forEach(s),Oa=l(Je," and "),Ne=i(Je,"A",{href:!0});var Xl=n(Ne);Ia=l(Xl,"DatasetFilter"),Xl.forEach(s),La=l(Je," classes (i.e. strings)."),Je.forEach(s),Qt=f(e),_(ue.$$.fragment,e),Vt=f(e),V=i(e,"P",{});var us=n(V);za=l(us,`As you can see, it found the models that fit all the criteria. You can even take it further
by passing in an array for each of the parameters from before. For example, let\u2019s take a look
for the same configuration, but also include `),yt=i(us,"CODE",{});var Zl=n(yt);Ba=l(Zl,"TensorFlow"),Zl.forEach(s),Ra=l(us," in the filter:"),us.forEach(s),es=f(e),_(me.$$.fragment,e),ts=f(e),Oe=i(e,"P",{});var Ql=n(Oe);Ja=l(Ql,"This query is strictly equivalent to:"),Ql.forEach(s),ss=f(e),_(de.$$.fragment,e),as=f(e),T=i(e,"P",{});var te=n(T);Ga=l(te,"Here, the "),Ie=i(te,"A",{href:!0});var Vl=n(Ie);Ka=l(Vl,"ModelSearchArguments"),Vl.forEach(s),Ua=l(te,` has been a helper to explore the options available on the Hub.
However, it is not a requirement to make a search. Another way to do that is to visit the
`),ge=i(te,"A",{href:!0,rel:!0});var er=n(ge);Wa=l(er,"models"),er.forEach(s),Ya=l(te," and "),_e=i(te,"A",{href:!0,rel:!0});var tr=n(_e);Xa=l(tr,"datasets"),tr.forEach(s),Za=l(te,` pages
in your browser, search for some parameters and look at the values in the URL.`),te.forEach(s),this.h()},h(){c(u,"name","hf:doc:metadata"),c(u,"content",JSON.stringify(fr)),c(k,"id","searching-the-hub"),c(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(k,"href","#searching-the-hub"),c(d,"class","relative group"),c(G,"id","how-to-list-repositories"),c(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(G,"href","#how-to-list-repositories"),c(I,"class","relative group"),c(ye,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi"),c(we,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.list_models"),c($e,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.list_datasets"),c(xe,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi.list_spaces"),c(U,"id","how-to-filter-repositories"),c(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(U,"href","#how-to-filter-repositories"),c(z,"class","relative group"),c(Ee,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelFilter"),c(ke,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.DatasetFilter"),c(Ae,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelFilter"),c(Y,"id","how-to-explore-filter-options"),c(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Y,"href","#how-to-explore-filter-options"),c(B,"class","relative group"),c(Me,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelSearchArguments"),c(He,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.DatasetSearchArguments"),sr(Se.src,Qa="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/search_text_classification.gif")||c(Se,"src",Qa),c(Se,"alt","Animation exploring `model_args.pipeline_tag`"),sr(qe.src,Va="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/search_glue.gif")||c(qe,"src",Va),c(qe,"alt","Animation exploring `model_args.dataset`"),c(Ce,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelFilter"),c(Ne,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.DatasetFilter"),c(Ie,"href","/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.ModelSearchArguments"),c(ge,"href","https://huggingface.co/models"),c(ge,"rel","nofollow"),c(_e,"href","https://huggingface.co/datasets"),c(_e,"rel","nofollow")},m(e,o){t(document.head,u),h(e,J,o),h(e,d,o),t(d,k),t(k,C),b($,C,null),t(d,se),t(d,N),t(N,O),h(e,j,o),h(e,F,o),t(F,ve),t(F,Ge),t(Ge,ds),t(F,gs),h(e,xt,o),h(e,I,o),t(I,G),t(G,Ke),b(ae,Ke,null),t(I,_s),t(I,Ue),t(Ue,bs),h(e,jt,o),h(e,L,o),t(L,We),t(We,vs),t(L,ys),t(L,ye),t(ye,ws),t(L,$s),h(e,Et,o),b(le,e,o),h(e,kt,o),h(e,K,o),t(K,xs),t(K,we),t(we,js),t(K,Es),h(e,At,o),h(e,M,o),t(M,ks),t(M,$e),t($e,As),t(M,Ts),t(M,xe),t(xe,Fs),t(M,Ms),h(e,Tt,o),h(e,z,o),t(z,U),t(U,Ye),b(re,Ye,null),t(z,Hs),t(z,Xe),t(Xe,Ps),h(e,Ft,o),h(e,je,o),t(je,Ss),h(e,Mt,o),h(e,A,o),t(A,Ze),t(Ze,Qe),t(Qe,Ds),t(A,qs),t(A,Ve),t(Ve,et),t(et,Cs),t(A,Ns),t(A,tt),t(tt,st),t(st,Os),t(A,Is),t(A,at),t(at,Ls),h(e,Ht,o),h(e,m,o),t(m,zs),t(m,lt),t(lt,Bs),t(m,Rs),t(m,rt),t(rt,Js),t(m,Gs),t(m,it),t(it,Ks),t(m,Us),t(m,ot),t(ot,Ws),t(m,Ys),t(m,Ee),t(Ee,Xs),t(m,Zs),t(m,ke),t(ke,Qs),t(m,Vs),h(e,Pt,o),h(e,W,o),t(W,ea),t(W,Ae),t(Ae,ta),t(W,sa),h(e,St,o),b(ie,e,o),h(e,Dt,o),h(e,Te,o),t(Te,aa),h(e,qt,o),b(oe,e,o),h(e,Ct,o),h(e,B,o),t(B,Y),t(Y,nt),b(ne,nt,null),t(B,la),t(B,ht),t(ht,ra),h(e,Nt,o),h(e,Fe,o),t(Fe,ia),h(e,Ot,o),h(e,E,o),t(E,Me),t(Me,oa),t(E,na),t(E,He),t(He,ha),t(E,pa),t(E,pt),t(pt,fa),t(E,ca),t(E,ft),t(ft,ua),t(E,ma),h(e,It,o),b(he,e,o),h(e,Lt,o),b(X,e,o),h(e,zt,o),h(e,Z,o),t(Z,da),t(Z,ct),t(ct,ga),t(Z,_a),h(e,Bt,o),b(pe,e,o),h(e,Rt,o),h(e,H,o),t(H,ba),t(H,ut),t(ut,va),t(H,ya),t(H,mt),t(mt,wa),t(H,$a),h(e,Jt,o),h(e,Q,o),t(Q,xa),t(Q,dt),t(dt,ja),t(Q,Ea),h(e,Gt,o),b(fe,e,o),h(e,Kt,o),h(e,P,o),t(P,ka),t(P,gt),t(gt,Aa),t(P,Ta),t(P,_t),t(_t,Fa),t(P,Ma),h(e,Ut,o),b(ce,e,o),h(e,Wt,o),h(e,S,o),t(S,Ha),t(S,bt),t(bt,Pa),t(S,Sa),t(S,vt),t(vt,Da),t(S,qa),h(e,Yt,o),h(e,Pe,o),t(Pe,Se),h(e,Xt,o),h(e,De,o),t(De,qe),h(e,Zt,o),h(e,D,o),t(D,Ca),t(D,Ce),t(Ce,Na),t(D,Oa),t(D,Ne),t(Ne,Ia),t(D,La),h(e,Qt,o),b(ue,e,o),h(e,Vt,o),h(e,V,o),t(V,za),t(V,yt),t(yt,Ba),t(V,Ra),h(e,es,o),b(me,e,o),h(e,ts,o),h(e,Oe,o),t(Oe,Ja),h(e,ss,o),b(de,e,o),h(e,as,o),h(e,T,o),t(T,Ga),t(T,Ie),t(Ie,Ka),t(T,Ua),t(T,ge),t(ge,Wa),t(T,Ya),t(T,_e),t(_e,Xa),t(T,Za),ls=!0},p(e,[o]){const be={};o&2&&(be.$$scope={dirty:o,ctx:e}),X.$set(be)},i(e){ls||(v($.$$.fragment,e),v(ae.$$.fragment,e),v(le.$$.fragment,e),v(re.$$.fragment,e),v(ie.$$.fragment,e),v(oe.$$.fragment,e),v(ne.$$.fragment,e),v(he.$$.fragment,e),v(X.$$.fragment,e),v(pe.$$.fragment,e),v(fe.$$.fragment,e),v(ce.$$.fragment,e),v(ue.$$.fragment,e),v(me.$$.fragment,e),v(de.$$.fragment,e),ls=!0)},o(e){y($.$$.fragment,e),y(ae.$$.fragment,e),y(le.$$.fragment,e),y(re.$$.fragment,e),y(ie.$$.fragment,e),y(oe.$$.fragment,e),y(ne.$$.fragment,e),y(he.$$.fragment,e),y(X.$$.fragment,e),y(pe.$$.fragment,e),y(fe.$$.fragment,e),y(ce.$$.fragment,e),y(ue.$$.fragment,e),y(me.$$.fragment,e),y(de.$$.fragment,e),ls=!1},d(e){s(u),e&&s(J),e&&s(d),w($),e&&s(j),e&&s(F),e&&s(xt),e&&s(I),w(ae),e&&s(jt),e&&s(L),e&&s(Et),w(le,e),e&&s(kt),e&&s(K),e&&s(At),e&&s(M),e&&s(Tt),e&&s(z),w(re),e&&s(Ft),e&&s(je),e&&s(Mt),e&&s(A),e&&s(Ht),e&&s(m),e&&s(Pt),e&&s(W),e&&s(St),w(ie,e),e&&s(Dt),e&&s(Te),e&&s(qt),w(oe,e),e&&s(Ct),e&&s(B),w(ne),e&&s(Nt),e&&s(Fe),e&&s(Ot),e&&s(E),e&&s(It),w(he,e),e&&s(Lt),w(X,e),e&&s(zt),e&&s(Z),e&&s(Bt),w(pe,e),e&&s(Rt),e&&s(H),e&&s(Jt),e&&s(Q),e&&s(Gt),w(fe,e),e&&s(Kt),e&&s(P),e&&s(Ut),w(ce,e),e&&s(Wt),e&&s(S),e&&s(Yt),e&&s(Pe),e&&s(Xt),e&&s(De),e&&s(Zt),e&&s(D),e&&s(Qt),w(ue,e),e&&s(Vt),e&&s(V),e&&s(es),w(me,e),e&&s(ts),e&&s(Oe),e&&s(ss),w(de,e),e&&s(as),e&&s(T)}}}const fr={local:"searching-the-hub",sections:[{local:"how-to-list-repositories",title:"How to list repositories ?"},{local:"how-to-filter-repositories",title:"How to filter repositories ?"},{local:"how-to-explore-filter-options",title:"How to explore filter options ?"}],title:"Searching the Hub"};function cr($t){return or(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _r extends ar{constructor(u){super();lr(this,u,cr,pr,rr,{})}}export{_r as default,fr as metadata};
